<script setup>
import { ref, computed } from 'vue'
import axios from 'axios'
import { parseDate } from '@/utils';

const props = defineProps({
  event: Object
})

const event = computed(() => props.event)

const timeslotId = computed(() => {
  if (event.value === null) return
  return event.value.id
})

const startDate = computed(() => {
  if (event.value === null) return
  return parseDate(event.value.start)
})

const endDate = computed(() => {
  if (event.value === null) return
  return parseDate(event.value.end)
})

const subject = computed(() => {
  if (event.value === null) return
  return event.value.title
})

const location = computed(() => {
  if (event.value === null) return
  return event.value.location
})

const attendees = computed(() => {
  if (event.value === null) return
  return event.value.attendees
})

const promotions = computed(() => {
  if (event.value === null) return
  return event.value.body
})

const infoValid = "Timeslot deleted!"
const infoText = ref('')

const emit = defineEmits(['exit'])

function deleteTimeslot() {

  axios.delete(`${import.meta.env.VITE_GESTION_EDT_API_URL}/creneaux/${timeslotId.value}`, {
    headers : {
      'Content-Type': 'application/json',
      'Accept': 'application/json'
    },
  })
    .then(() => {
      infoText.value = infoValid
      setTimeout(() => {
        emit('exit')
      }, 2000)
    })
    .catch(e => {
      infoText.value = 'Error deleting timeslot!'
  })
}
</script>

<template>
  <div class="delete">
    <form class="mb-4">
      <p>Are you sure you want to delete this timeslot?</p>
      <p>{{ startDate }} - {{ endDate }}</p>
      <p>{{ subject }}</p>
      <p>{{ location }}</p>
      <p>{{ attendees }}</p>
      <p>{{ promotions }}</p>
      <button type="submit" class="btn btn-danger" @click.prevent="deleteTimeslot">Delete</button>
      <p class="mt-3" :class="infoText === infoValid ? 'text-success' : 'text-danger'">{{ infoText }}</p>
    </form>
  </div>
</template>

<style scoped>

</style>